#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <conio.h>
#include <ctype.h>
#include <windows.h>

typedef int (WINAPI *VeryPDF_PSToPDFFunc)(LPCTSTR lpCommand);
VeryPDF_PSToPDFFunc VeryPDF_PSToPDF = NULL;

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL ConvertPS2PDF(char *lpCmd)
{
	char path[_MAX_PATH];
	HINSTANCE hPS2PDF = NULL;
	BOOL bRet;
#ifdef _WIN64
	GetModulePath(path,"ps2pdf_x64.dll");
#else
	GetModulePath(path,"ps2pdf_x86.dll");
#endif
	printf("LoadLibrary(\"%s\")\n", path);
	hPS2PDF = LoadLibrary(path);
	if(hPS2PDF == NULL)
	{
		printf("Load '%s' file failed.\n", path);
		return FALSE;
	}
	printf("Load '%s' file successful.\n", path);
	VeryPDF_PSToPDF=(VeryPDF_PSToPDFFunc)GetProcAddress(hPS2PDF,"VeryPDF_PSToPDF");
	if(VeryPDF_PSToPDF==NULL)
		return FALSE;
	printf("Get 'VeryPDF_PSToPDF' function successful.\n");
	bRet = VeryPDF_PSToPDF(lpCmd);
	FreeLibrary(hPS2PDF);
	printf("Execute function successful.\n");
	return bRet;
}
void main(int argc, char *argv[])
{
	int i;
	char *lpLicenseKey = "XXXXXXXXXXXXXXXXXX";
	char szCommandLine[2048] = {0};
	int nRet = 0;

	if(argc < 2)
	{
		printf("test.exe C:\\test.ps\n");
		printf("test.exe C:\\test.ps C:\\test.pdf\n");
		return;
	}

	//sprintf(szCommandLine,"ps2pdf -mode 0 -$ \"%s\" ",lpLicenseKey);
	//sprintf(szCommandLine,"ps2pdf -mode 1 -$ \"%s\" ",lpLicenseKey);
	//sprintf(szCommandLine,"ps2pdf -mode 2 -$ \"%s\" ",lpLicenseKey);
	//sprintf(szCommandLine,"ps2pdf -mode 3 -$ \"%s\" ",lpLicenseKey);
	//sprintf(szCommandLine,"ps2pdf -mode 4 -$ \"%s\" ",lpLicenseKey);
	sprintf(szCommandLine,"ps2pdf -$ \"%s\" ",lpLicenseKey);
	for(i = 1; i < argc; i++)
	{
		strcat(szCommandLine, " \"");
		strcat(szCommandLine, argv[i]);
		strcat(szCommandLine, "\"");
	}
	nRet = ConvertPS2PDF(szCommandLine);
	printf("nRet = %d\n", nRet);
}